Index: /trunk/src/sh_utils.c
===================================================================
--- /trunk/src/sh_utils.c	(revision 584)
+++ /trunk/src/sh_utils.c	(revision 1)
@@ -27,8 +27,15 @@
 #include <unistd.h>
 
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
-#endif
+#else
 #include <time.h>
+#endif
+#endif
+
 
 #include "samhain.h"
@@ -38,5 +45,4 @@
 #include "sh_tiger.h"
 #include "sh_entropy.h"
-#include "sh_pthread.h"
 
 #undef  FIL__
@@ -45,5 +51,5 @@
 UINT32 ErrFlag[2];
 
-int sh_util_flagval(const char * c, int * fval)
+int sh_util_flagval(char * c, int * fval)
 {
   SL_ENTER(_("sh_util_flagval"));
@@ -95,45 +101,15 @@
 static int sh_ask_update = S_FALSE;
 
-int sh_util_set_interactive(const char * str)
-{
-  (void) str;
-
-  sh_ask_update = S_TRUE;
+int sh_util_set_interactive(char * str)
+{
+  if (str == NULL)
+    sh_ask_update = S_TRUE;
+  else
+    sh_ask_update = S_TRUE;
+
   sh_unix_setnodeamon(NULL);
 
   return 0;
 }
-
-static char * sh_update_file = NULL;
-
-int sh_util_update_file (const char * str)
-{
-  if (str)
-    {
-      if (0 == access(str, R_OK)) /* flawfinder: ignore */
-	{
-	  if (NULL != sh_update_file)
-	    SH_FREE(sh_update_file);
-	  sh_update_file = sh_util_strdup(str);
-	  sh_ask_update = S_TRUE;
-	  sh_unix_setnodeamon(NULL);
-	  return 0;
-	}
-      else
-	{
-	  char ebuf[SH_ERRBUF_SIZE];
-	  int  errnum = errno;
-
-	  sh_error_message(errnum, ebuf, sizeof(ebuf));
-	  sh_error_handle (SH_ERR_ERR, FIL__, __LINE__, errnum, MSG_E_SUBGEN,
-			   ebuf, _("sh_util_update_file") );
-	  
-	  return -1;
-	}
-    }
-
-  return -1;
-}
-
 
 #if !defined(STDIN_FILENO)
@@ -144,54 +120,5 @@
 #endif
 
-/* Returns S_FALSE if no update desired 
- */
-int sh_util_update_checkfile(const char * path)
-{
-  FILE * fd = fopen(sh_update_file, "r");
-  char * line;
-
-  if (!fd)
-    {
-      uid_t  euid;
-      int errnum = errno;
-      sl_get_euid(&euid);
-      sh_error_handle (SH_ERR_ERR, FIL__, __LINE__, errnum, MSG_NOACCESS,
-		       (long) euid, sh_update_file);
-      aud_exit (FIL__, __LINE__, EXIT_FAILURE);
-      return S_FALSE;
-    }
-
-  line = SH_ALLOC(8192);
-
-  while (NULL != fgets(line, 8192, fd))
-    {
-      char * nl = strrchr(line, '\n');
-
-      if (nl)
-	{
-	  *nl = '\0';
-
-	  /* Check for MS Windows line terminator 
-	   */
-	  if (nl > line) --nl;
-	  if (*nl == '\r')
-	    *nl = '\0';
-	}
-
-      if (0 == sl_strcmp(line, path))
-	{
-	  SH_FREE(line);
-	  fclose(fd);
-	  return S_TRUE;
-	}
-    }
-  SH_FREE(line);
-  fclose(fd);
-  return S_FALSE;
-}
-
-/* Returns S_FALSE if no update desired 
- */
-int sh_util_ask_update(const char * path)
+int sh_util_ask_update(char * path)
 {
   int    inchar, c;
@@ -206,10 +133,4 @@
     }
 
-  if (sh_update_file)
-    {
-      i = sh_util_update_checkfile(path);
-      SL_RETURN(i, _("sh_util_ask_update"));
-    }
-
 #ifdef HAVE_TTYNAME
   if (!ttyname(STDIN_FILENO))
@@ -217,5 +138,4 @@
       if (NULL != ttyname(STDERR_FILENO))
         {
-	  /* cppcheck-suppress leakReturnValNotUsed */
           if (NULL == freopen(ttyname(STDERR_FILENO), "r", stdin))
             {
@@ -261,5 +181,5 @@
 	  else
 	    {
-	      fprintf(stderr, "%s", _("Please answer y(es) or n(o)\n"));
+	      fprintf(stderr, _("Please answer y(es) or n(o)\n"));
 	    }
 	  /*@-charintliteral@*/
@@ -270,5 +190,5 @@
 }
 
-int sh_util_hidesetup(const char * c)
+int sh_util_hidesetup(char * c)
 {
   int i;
@@ -278,98 +198,5 @@
   SL_RETURN(i, _("sh_util_hidesetup"));
 }
-
-char * sh_util_acl_compact(char * buf, ssize_t len)
-{
-  unsigned char  * p = (unsigned char *) buf;
-  int       state = 0;
-  ssize_t   rem = 0;
-  char    * out;
-  
-  SH_VALIDATE_NE(buf, NULL);
-  SH_VALIDATE_GE(len, 0);
-
-  out = SH_ALLOC(len + 1);
-
-  while (*p != '\0')  {
-
-    /* -- not at start or after newline
-     */
-    if (state == 1) {
-      if (*p == '\n' || *p == ' ' || *p == '\t' || *p == '#') {
-	while (*p != '\n') {
-	  ++p;
-	  if (*p == '\0') {
-	    goto exit_it;
-	  }
-	}
-	out[rem] = ','; ++rem;    /* <-- ensures (rem > 0) is true    */ 
-	while (p[1] == '\n') ++p; /* scan over consecutive newlines   */
-	state = 0;
-	if (p[1] == '\0') {
-	  out[rem-1] = '\0';      /* rem > 0 because of 4 lines above */
-	  break;
-	}
-      }
-      else {
-	if (*p <= 0x7F && isgraph((int) *p)) {
-	  out[rem] = (char) *p; ++rem;
-	}
-      }
-    }
-
-    /* -- at start or after newline
-     */
-    else /* if (state == 0) */ {
-      if        (0 == strncmp((char *) p, "user", 4)) {
-	out[rem] = 'u'; ++rem;
-	p += 3;
-      } else if (0 == strncmp((char *) p, "group", 5)) {
-	out[rem] = 'g'; ++rem;
-	p += 4; 
-      } else if (0 == strncmp((char *) p, "mask", 4)) {
-	out[rem] = 'm'; ++rem;
-	p += 3;
-      } else if (0 == strncmp((char *) p, "other", 5)) {
-	out[rem] = 'o';
-	p += 4; ++rem;
-      } else if (*p == '\0') {
-	if (rem > 0) { out[rem-1] = '\0'; }
-	break;
-      } else {
-	if (*p <= 0x7F && isprint((int) *p)) {
-	  out[rem] = (char) *p; ++rem;
-	}
-      }
-      state = 1;
-    }
-    ++p;
-  }
- exit_it:
-  out[rem] = '\0';
-  return out;
-}
-
-
-char * sh_util_strdup_l (const char * str, size_t len)
-{
-  char * p = NULL;
-
-  SL_ENTER(_("sh_util_strdup_l"));
-
-  SH_VALIDATE_NE(str, NULL);
-  SH_VALIDATE_NE(len, 0);
-
-  if (str && sl_ok_adds (len, 1))
-    {
-      p   = SH_ALLOC (len + 1);
-      (void) memcpy (p, str, len+1);
-    }
-  else
-    {
-      safe_fatal(_("integer overflow in sh_util_strdup_l"), FIL__, __LINE__);
-    }
-  SL_RETURN( p, _("sh_util_strdup_l"));
-}
-
+    
 char * sh_util_strdup (const char * str) 
 {
@@ -379,31 +206,11 @@
   SL_ENTER(_("sh_util_strdup"));
 
-  SH_VALIDATE_NE(str, NULL);
-
-  if (str)
+  if (str != NULL)
     {
       len = sl_strlen(str);
       p   = SH_ALLOC (len + 1);
-      (void) memcpy (p, str, len+1);
+      (void) sl_strlcpy (p, str, len+1);
     }
   SL_RETURN( p, _("sh_util_strdup"));
-}
-
-char * sh_util_strdup_track (const char * str, char * file, int line) 
-{
-  char * p = NULL;
-  size_t len;
-
-  SL_ENTER(_("sh_util_strdup_track"));
-
-  SH_VALIDATE_NE(str, NULL);
-
-  if (str)
-    {
-      len = sl_strlen(str);
-      p   = SH_OALLOC (len + 1, file, line);
-      (void) memcpy (p, str, len+1);
-    }
-  SL_RETURN( p, _("sh_util_strdup_track"));
 }
 
@@ -413,24 +220,22 @@
 char * sh_util_strsep (char **str, const char *delim) 
 {
-  char *ret, *c;
-  const char *d;
+  char *ret, *c, *d;
 
   SL_ENTER(_("sh_util_strsep"));
   ret = *str;
 
-  SH_VALIDATE_NE(ret, NULL);
-
-  if (*str)
-    {
-      for (c = *str; *c != '\0'; c++) {
-	for (d = delim; *d != '\0'; d++) {
-	  if (*c == *d) {
-	    *c = '\0';
-	    *str = c + 1;
-	    SL_RETURN(ret, _("sh_util_strsep"));
-	  }
-	}
+  if (ret == NULL) {
+    SL_RETURN(ret, _("sh_util_strsep"));
+  }
+
+  for (c = *str; *c != '\0'; c++) {
+    for (d = (char *) delim; *d != '\0'; d++) {
+      if (*c == *d) {
+        *c = '\0';
+        *str = c + 1;
+        SL_RETURN(ret, _("sh_util_strsep"));
       }
     }
+  }
 
   /* If we get to here, there's no delimiters in the string */
@@ -440,5 +245,5 @@
 
 
-/* returned string must be free'd by caller.
+/* returned string must be free'd by caller
  */
 char * sh_util_formatted (const char * formatt, st_format * ftab)
@@ -455,11 +260,10 @@
   time_t inpp;
 
-  char * clist[16] = { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
-		       NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL };
+  char * clist[16];
   int    nn = 0;
 
   SL_ENTER(_("sh_util_formatted"));
 
-  if (formatt == NULL || ftab == NULL || *formatt == '\0')
+  if (formatt == NULL || ftab == NULL)
     SL_RETURN(NULL, _("sh_util_formatted"));
 
@@ -467,21 +271,25 @@
    */
   size = sl_strlen(formatt);
-
-  if (!sl_ok_adds(size, 1))
+  if (size > 0)
+    {
+      fmt = (char *) SH_ALLOC(size + 1);
+      (void) sl_strlcpy(fmt, formatt, size + 1);
+    }
+  else
     SL_RETURN(NULL, _("sh_util_formatted"));
 
-  ++size;
-  fmt = SH_ALLOC(size);
-  (void) sl_strlcpy(fmt, formatt, size);
-
   p = fmt;
 
   j = 0;
-  while (ftab[j].fchar != '\0') {
-    if (ftab[j].type != S_FMT_STRING)
-      ftab[j].data_str = NULL;
-    ++j;
-  }
- 
+  while (ftab[j].fchar != '\0')
+    {
+      if (ftab[j].type != S_FMT_STRING)
+	ftab[j].data_str = NULL;
+      ++j;
+    }
+
+  for (j = 0; j < 16; ++j)
+    clist[j] = NULL;
+
   while (p != NULL && *p != '\0' && NULL != (q = strchr(p, '%')))
     {
@@ -516,10 +324,8 @@
 	      i  = 1;
 	      
-	      switch(ftab[j].type) {
-
-	      case S_FMT_STRING:
+	      if (ftab[j].type == S_FMT_STRING)
 		{
 		  isiz = sl_strlen(ftab[j].data_str);
-		  if (isiz > 0 && sl_ok_adds(size, isiz))
+		  if (isiz > 0)
 		    {
 		      size += isiz;
@@ -529,9 +335,7 @@
 		  else
 		    *q = '%';
-		  goto endsrch;
+		  break;
 		}
-		break;
-
-	      case S_FMT_ULONG:
+	      else if (ftab[j].type == S_FMT_ULONG)
 		{
 		  ftab[j].data_str = (char *) SH_ALLOC(64);
@@ -541,5 +345,5 @@
 		  /*@+bufferoverflowhigh@*/
 		  isiz = sl_strlen(ftab[j].data_str);
-		  if (isiz > 0 && sl_ok_adds(size, isiz))
+		  if (isiz > 0)
 		    {
 		      size += isiz;
@@ -549,9 +353,7 @@
 		  else
 		    *q = '%';
-		  goto endsrch;
+		  break;
 		}
-		break;
-
-	      case S_FMT_LONG:
+	      else if (ftab[j].type == S_FMT_LONG)
 		{
 		  ftab[j].data_str = (char *) SH_ALLOC(64);
@@ -561,5 +363,5 @@
 		  /*@+bufferoverflowhigh@*/
 		  isiz = sl_strlen(ftab[j].data_str);
-		  if (isiz > 0 && sl_ok_adds(size, isiz))
+		  if (isiz > 0)
 		    {
 		      size += isiz;
@@ -569,9 +371,7 @@
 		  else
 		    *q = '%';
-		  goto endsrch;
+		  break;
 		}
-		break;
-
-	      case S_FMT_TIME:
+	      else if (ftab[j].type == S_FMT_TIME)
 		{
 		  ftab[j].data_str = (char *) SH_ALLOC(64);
@@ -593,5 +393,5 @@
 		    }
 		  isiz = sl_strlen(ftab[j].data_str);
-		  if (isiz > 0 && sl_ok_adds(size, isiz))
+		  if (isiz > 0)
 		    {
 		      size += isiz;
@@ -601,19 +401,11 @@
 		  else
 		    *q = '%';
-		  goto endsrch;
+		  break;
 		}
-		break;
-
-	      default:
-		/* do nothing */;
-	      }
 
 	    }
-	  ++j;
-	}
-
-    endsrch:
-
-      p = q;
+	  else
+	    ++j;
+	}
 
       /* -- not found -- */
@@ -621,7 +413,11 @@
 	{
 	  *q = '%';
+	  p = q;
 	  ++p;
 	}
-
+      else
+	{
+	  p = q;
+	}
     }
 
@@ -633,6 +429,5 @@
   /* -- closing '\0' --
    */
-  if (sl_ok_adds(size, 1))
-    size++;
+  size++;
   outstr = (char *) SH_ALLOC(size);
 
@@ -644,14 +439,14 @@
 		      clist[8],  clist[9], clist[10], clist[11], 
 		      clist[12], clist[13], clist[14], clist[15]); 
-  outstr[size-1] = '\0';
-
+  
   /* -- cleanup --
    */
   j = 0;
-  while (ftab[j].fchar != '\0') {
-    if (ftab[j].type != S_FMT_STRING && ftab[j].data_str != NULL)
-      SH_FREE(ftab[j].data_str);
-    ++j;
-  }
+  while (ftab[j].fchar != '\0')
+    {
+      if (ftab[j].type != S_FMT_STRING && ftab[j].data_str != NULL)
+	SH_FREE(ftab[j].data_str);
+      ++j;
+    }
   SH_FREE(fmt);
 
@@ -659,8 +454,7 @@
 }
 
-/* read a hexchar, return int value (0-15)
- * can't inline (AIX)
- */
-int sh_util_hexchar( const char c )
+/* can't inline (AIX)
+ */
+int sh_util_hexchar( char c )
 {
   /*@+charint@*/
@@ -675,51 +469,24 @@
 }
 
-char * sh_util_charhex( unsigned char i , char * i2h)
-{
-  int j, k;
-
-  j = i / 16;
-  k = i - (j*16);
-
-  if (j < 10) i2h[0] = '0'+j;
-  else        i2h[0] = 'A'+(j-10);
-  
-  if (k < 10) i2h[1] = '0'+k;
-  else        i2h[1] = 'A'+(k-10);
-
-  return i2h;
-}
-
 /* read a hexadecimal key, convert to binary
  */
-int sh_util_hextobinary (char * binary, const char * hex, int bytes)
+int sh_util_hextobinary (char * binary, char * hex, int bytes)
 {
   int i = 0, j, k, l = 0;
-  char c;
-
-#define SH_HEXCHAR(x, y) \
-    c = (x); \
-    if ( c >= '0' && c <= '9' ) \
-      y = c - '0'; \
-    else if ( c >= 'a' && c <= 'f' ) \
-      y = c - 'a' + 10; \
-    else if ( c >= 'A' && c <= 'F' ) \
-      y = c - 'A' + 10; \
-    else \
-      SL_RETURN((-1), _("sh_util_hextobinary"))
-
 
   SL_ENTER(_("sh_util_hextobinary"));
 
-  if (bytes < 2)
-    SL_RETURN((-1), _("sh_util_hextobinary"));
-
-  while (i < (bytes-1))
-    {
-      SH_HEXCHAR(hex[i],   k);
-      SH_HEXCHAR(hex[i+1], j);
-      
-      binary[l] = (char)(k * 16 + j);
-      ++l; i+= 2;
+  while (i < bytes)
+    {
+      k = sh_util_hexchar(hex[i]); j = sh_util_hexchar(hex[i+1]); 
+      if (k != -1 && j != -1) 
+        {
+          binary[l] = (char)(k * 16 + j);
+          ++l; i+= 2;
+        }
+      else
+        {
+	  SL_RETURN((-1), _("sh_util_hextobinary"));
+        }
     }
   
@@ -746,6 +513,5 @@
  */
 static char * sh_util_hmac_tiger (char * hexkey,  
-				  char * text, size_t textlen,
-				  char * res, size_t len)
+				  char * text, size_t textlen)
 {
   static char opad[KEY_BLOCK] = { 
@@ -761,10 +527,4 @@
     (char)0x36, (char)0x36, (char)0x36, (char)0x36, (char)0x36, (char)0x36
   };
-  static char  zap[KEY_BLOCK] = { 
-    (char)0x00, (char)0x00, (char)0x00, (char)0x00, (char)0x00, (char)0x00,  
-    (char)0x00, (char)0x00, (char)0x00, (char)0x00, (char)0x00, (char)0x00,  
-    (char)0x00, (char)0x00, (char)0x00, (char)0x00, (char)0x00, (char)0x00,  
-    (char)0x00, (char)0x00, (char)0x00, (char)0x00, (char)0x00, (char)0x00
-  };
   char        K[KEY_BLOCK];
   char        outer[KEY_BLOCK];
@@ -773,90 +533,78 @@
   UINT32    * h2;
   UINT32      cc[KEY_LEN/4];
-  UINT32      kbuf[KEY_BYT/sizeof(UINT32)];
-  char hashbuf[KEYBUF_SIZE];
-
-  int         result;
+  char      * res;
+
   size_t      i;
 
   SL_ENTER(_("sh_util_hmac_tiger"));
-
-  ASSERT((KEY_BLOCK <= (KEY_LEN/2)), _("KEY_BLOCK <= (KEY_LEN/2)"));
-
-  memcpy (K, zap, KEY_BLOCK);
-
-  result = sh_util_hextobinary (K, hexkey, KEY_LEN);
-
-  ASSERT((result >= 0), _("result >= 0"));
-
-  if ((result >= 0) && sl_ok_adds(textlen, KEY_BLOCK))
-    {
-      inner = (char *) SH_ALLOC (textlen + KEY_BLOCK); 
-
-      for (i = 0; i < KEY_BLOCK; ++i)
-	{
-	  outer[i]  = K[i] ^ opad[i];
-	  inner[i]  = K[i] ^ ipad[i];
-	}
-      for (i = KEY_BLOCK; i < (KEY_BLOCK+textlen); ++i)
-	{
-	  inner[i] = text[i - KEY_BLOCK];
-	}
-    }
-  else
-    {
-      sh_error_handle((-1), FIL__, __LINE__, -1, MSG_E_SUBGEN,
-		      _("integer overflow"), 
-		      _("sh_util_hmac_tiger"));
-      (void) sh_tiger_hash (NULL, TIGER_DATA, 0, hashbuf, sizeof(hashbuf));
-      sl_strlcpy(res, hashbuf, len);
+  ASSERT((KEY_BLOCK <= (KEY_LEN/2)), _("KEY_BLOCK <= (KEY_LEN/2)"))
+
+  if (KEY_BLOCK > (KEY_LEN/2))
+    {
+      res = sh_tiger_hash (NULL, TIGER_DATA, 0);
       SL_RETURN(res, _("sh_util_hmac_tiger"));
+    }
+
+  memset (K, 0x00, KEY_BLOCK);
+
+  if (sh_util_hextobinary (K, hexkey, KEY_LEN) < 0)
+    {
+      res = sh_tiger_hash (NULL, TIGER_DATA, 0);
+      SL_RETURN(res, _("sh_util_hmac_tiger"));
+    }
+
+  inner = (char *) SH_ALLOC (textlen + KEY_BLOCK); 
+
+  for (i = 0; i < KEY_BLOCK; ++i)
+    {
+      outer[i]  = K[i] ^ opad[i];
+      inner[i]  = K[i] ^ ipad[i];
+    }
+  for (i = KEY_BLOCK; i < (KEY_BLOCK+textlen); ++i)
+    {
+      inner[i] = text[i - KEY_BLOCK];
     }
 
   /* now compute the hash 
    */
-  h1 = sh_tiger_hash_uint32 ( outer, TIGER_DATA, KEY_BLOCK,
-			      kbuf, KEY_BYT/sizeof(UINT32));
+  h1 = sh_tiger_hash_uint32 ( outer,
+			      TIGER_DATA,
+			      KEY_BLOCK);
   for (i = 0; i < (KEY_LEN/8); ++i)
-    copy_four ( (unsigned char *) &(cc[i]), h1[i]);
-
-  /* cppcheck-suppress uninitvar */
-  h2 = sh_tiger_hash_uint32 ( inner, TIGER_DATA,
-			      (unsigned long) KEY_BLOCK+textlen,
-			      kbuf, KEY_BYT/sizeof(UINT32));
+    {
+      /* cc[i] = h1[i]; */
+      copy_four ( (unsigned char *) &(cc[i]), h1[i]);
+    }
+
+  h2 = sh_tiger_hash_uint32 ( inner,
+			      TIGER_DATA,
+			      (unsigned long) KEY_BLOCK+textlen);
   for (i = KEY_LEN/8; i < (KEY_LEN/4); ++i)
-    copy_four ( (unsigned char *) &(cc[i]), h2[i - (KEY_LEN/8)]);
-
-  /* cppcheck-suppress uninitvar */
+    {
+      copy_four ( (unsigned char *) &(cc[i]), h2[i - (KEY_LEN/8)]);
+      /* cc[i] = h2[i - (KEY_LEN/8)]; */
+    }
   SH_FREE(inner);
   
-  (void) sh_tiger_hash ((char *) &cc[0],
-			TIGER_DATA,
-			(unsigned long) (KEY_LEN/4 * sizeof(UINT32)),
-			hashbuf, sizeof(hashbuf));
-
-  sl_strlcpy(res, hashbuf, len);
+  res = sh_tiger_hash ((char *) &cc[0],
+		       TIGER_DATA,
+		       (unsigned long) (KEY_LEN/4 * sizeof(UINT32)));
+
   SL_RETURN(res, _("sh_util_hmac_tiger"));
 }
 
 static char * sh_util_hash_tiger ( char * hexkey,  
-				   char * text, size_t textlen,
-				   char * res, size_t len)
-{
+				   char * text, size_t textlen)
+{
+  char         * res;
   char           h2[2*KEY_LEN+1];
-  char hashbuf[KEYBUF_SIZE];
-
   SL_ENTER(_("sh_util_hash_tiger"));
 
   (void) sl_strlcpy(h2, hexkey, KEY_LEN+1); 
-  (void) sl_strlcat(h2, 
-		    sh_tiger_hash(text, TIGER_DATA, 
-				  (unsigned long) textlen,
-				  hashbuf, sizeof(hashbuf)), 
-		    2*KEY_LEN+1
-		    );
-
-  (void) sh_tiger_hash(h2, TIGER_DATA, 2*KEY_LEN, hashbuf, sizeof(hashbuf));
-
-  sl_strlcpy(res, hashbuf, len);
+  (void) sl_strlcat(h2, sh_tiger_hash(text, TIGER_DATA, 
+				      (unsigned long) textlen), 2*KEY_LEN+1);
+
+  res = sh_tiger_hash(h2, TIGER_DATA, 2*KEY_LEN);
+
   SL_RETURN(res, _("sh_util_hash_tiger"));
 }
@@ -869,5 +617,5 @@
 static int sigtype = TYPE_HMAC;
 
-int sh_util_sigtype (const char * c)
+int sh_util_sigtype (char * c)
 {
   SL_ENTER(_("sh_util_sigtype"));
@@ -886,6 +634,5 @@
 
 char * sh_util_siggen (char * hexkey,  
-		       char * text, size_t textlen,
-		       char * res, size_t len)  
+		       char * text, size_t textlen)  
 {
   char * p;
@@ -894,15 +641,16 @@
   if (sigtype == TYPE_HMAC)
     p = sh_util_hmac_tiger (hexkey,  
-			    text, textlen, res, len);
+			    text, textlen);
   else
     p = sh_util_hash_tiger (hexkey,  
-			    text, textlen, res, len);
+			    text, textlen);
   SL_RETURN(p, _("sh_util_siggen"));
 }    
 
+  
  
 /* a simple compressor
  */
-size_t sh_util_compress (char * dest, char * src, size_t dest_size)
+long sh_util_compress (char * dest, char * src, size_t dest_size)
 {
   char * add;
@@ -945,5 +693,5 @@
 
   dest[dest_size-1] = '\0'; /* paranoia       */
-  SL_RETURN((count), _("sh_util_compress")); /* no of chars copied */    
+  SL_RETURN(((long)count), _("sh_util_compress")); /* no of chars copied */    
 }
 
@@ -959,8 +707,4 @@
     char c[sizeof(long)];
   } u;
-#ifdef WORDS_BIGENDIAN
-  unsigned char swap;
-  unsigned char * ii = (unsigned char *) dest;
-#endif
 
   SL_ENTER(_("sh_util_cpylong"));    
@@ -985,8 +729,4 @@
       ++i;
     }
-#ifdef WORDS_BIGENDIAN
-  swap = ii[0]; ii[0] = ii[3]; ii[3] = swap;
-  swap = ii[1]; ii[1] = ii[2]; ii[2] = swap;
-#endif
   SL_RET0(_("sh_util_cpylong"));
 }
@@ -1012,5 +752,5 @@
 
 
-/* interval [0, 4294967295]
+/* interval [0, 4294967296]
  */
 static UINT32 taus_get_long (void *vstate)
@@ -1018,8 +758,6 @@
   UINT32 * state = (UINT32 *) vstate;
 
-  /*
   if (skey->rngI == BAD)
     (void)taus_seed();
-  */
 
 #define TAUSWORTHE(s,a,b,c,d) ((s &c) <<d) ^ (((s <<a) ^s) >>b)
@@ -1035,53 +773,28 @@
  * input for a one-way hash function.
  */
-
-UINT32 taus_get ()
-{
-#define TAUS_SAMPLE 12
-
-  UINT32   taus_svec[TAUS_SAMPLE];
+UINT32 taus_get (void *state1, void *state2, void *state3)
+{
+  UINT32   svec[6];
   UINT32   retval;
   UINT32 * res;
-  UINT32 * res_vec = &(skey->res_vec[0]);
-  static   int      res_num = 0;
   register int i;
-  UINT32       kbuf[KEY_BYT/sizeof(UINT32)];
-
-  SH_MUTEX_LOCK_UNSAFE(mutex_skey);
-  if (res_num > 0)
-    {
-      retval  = res_vec[res_num];
-      res_num = (res_num == 5) ? 0 : (res_num + 1);
-      SH_MUTEX_UNLOCK_UNSAFE(mutex_skey); /* alternative path */
-      return  retval;
-    }
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
-
-  (void)taus_seed();
-
-  SH_MUTEX_LOCK_UNSAFE(mutex_skey);
-  for (i = 0; i < (TAUS_SAMPLE/3); ++i)
-    {
-      taus_svec[i*3]   = taus_get_long (&(skey->rng0[0]));
-      taus_svec[i*3+1] = taus_get_long (&(skey->rng1[0]));
-      taus_svec[i*3+2] = taus_get_long (&(skey->rng2[0]));
-    }
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
-
-  res     = sh_tiger_hash_uint32 ( (char *) &taus_svec[0], 
+
+  svec[0] = taus_get_long (state1);
+  svec[1] = taus_get_long (state2);
+  svec[2] = taus_get_long (state3);
+  svec[3] = taus_get_long (state1);
+  svec[4] = taus_get_long (state2);
+  svec[5] = taus_get_long (state3);
+
+  res     = sh_tiger_hash_uint32 ( (char *) &svec[0], 
 				   TIGER_DATA, 
-				   (unsigned long)(TAUS_SAMPLE * sizeof(UINT32)),
-				   kbuf, KEY_BYT/sizeof(UINT32));
-
-  SH_MUTEX_LOCK_UNSAFE(mutex_skey);
-  for (i = 1; i < 6; ++i)
-    { 
-      res_vec[i] = res[i];
-    }
-  retval  = res[0];
-  res_num = 1;
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
-
-  memset(taus_svec, 0, TAUS_SAMPLE * sizeof(UINT32));
+				   (unsigned long)(6 * sizeof(UINT32)));
+
+  for (i = 1; i < KEY_BYT/4; ++i)
+    res[0] ^= res[i];
+  retval = res[0];
+
+  memset (res,  0,            KEY_BYT);
+  memset (svec, 0, 6 * sizeof(UINT32));
 
   return retval;
@@ -1139,7 +852,5 @@
   char                 bufx[9 * sizeof(UINT32) + 1];
   int                  status;
-  static unsigned long seed_time    = 0;
-  static unsigned long seed_counter = 3000;
-  unsigned long        gtime;
+  static unsigned long seed_time = 0;
 
   SL_ENTER(_("taus_seed"));
@@ -1147,13 +858,9 @@
   if (skey->rngI == GOOD)
     {
-      ++seed_counter;
-
-      if ( ((sh_unix_longtime () - seed_time) < 1800) &&
-	   ( seed_counter                     < 3000))
+      if ( (sh_unix_longtime () - seed_time) < 3600)
 	SL_RETURN( (0), _("taus_seed"));
     }
   
-  seed_time    = sh_unix_longtime ();
-  seed_counter = 0;
+  seed_time = sh_unix_longtime ();
 
   status = sh_entropy (24, bufx);
@@ -1161,5 +868,5 @@
   if (!SL_ISERROR(status))
     {
-      SH_MUTEX_LOCK_UNSAFE(mutex_skey);
+      skey->rngI = GOOD;
       memcpy (&skey->rng0[0], &bufx[0],                  2*sizeof(UINT32));
       memcpy (&skey->rng1[0], &bufx[2*sizeof(UINT32)],   2*sizeof(UINT32));
@@ -1175,6 +882,4 @@
       taus_set_from_state( &(skey->rng2[0]), &(skey->rng2[0]));
 
-      skey->rngI = GOOD;
-      SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
       SL_RETURN( (0), _("taus_seed"));
     }
@@ -1185,16 +890,13 @@
   /* emergency backup - unsafe !
    */
+  skey->rngI = GOOD;
 #ifdef HAVE_GETTIMEOFDAY
-  gtime = sh_unix_notime();
+  taus_set_from_ulong ( &(skey->rng0[0]), LCG (sh_unix_notime())      );
 #else
-  gtime = seed_time;
-#endif
-
-  SH_MUTEX_LOCK_UNSAFE(mutex_skey);
-  taus_set_from_ulong ( &(skey->rng0[0]), LCG (gtime)          );
+  taus_set_from_ulong ( &(skey->rng0[0]), LCG (seed_time)      );
+#endif
   taus_set_from_ulong ( &(skey->rng1[0]), LCG (skey->rng0[0])  );
   taus_set_from_ulong ( &(skey->rng2[0]), LCG (skey->rng1[0])  );
   skey->rngI = BAD;
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_skey);
 
   SL_RETURN( (-1), _("taus_seed"));
@@ -1206,5 +908,5 @@
 static void copy_four (unsigned char * dest, UINT32 in);
 
-int sh_util_set_newkey (const char * new_in)
+int sh_util_set_newkey (char * new)
 {
   size_t i, j = 0;
@@ -1213,6 +915,6 @@
   SL_TICKET fout;
   char * key;
-  char * path = NULL;
-  char * outpath = NULL;
+  char * path;
+  char * outpath;
   unsigned char * image = NULL;
   long s = 0;
@@ -1220,9 +922,8 @@
   long ii, k = 0;
   UINT32    * h1;
-  char * new = NULL;
 
   if (0 != sl_is_suid())
     {
-      fprintf(stderr, "%s", _("ERROR: insufficient privilege\n"));
+      fprintf(stderr, _("ERROR: insufficient privilege\n"));
       _exit (EXIT_FAILURE);
       /*@notreached@*/
@@ -1230,7 +931,7 @@
     }
         
-  if (new_in == NULL || new_in[0] == '\0')
-    {
-      fprintf(stderr, "%s", 
+  if (new == NULL || new[0] == '\0')
+    {
+      fprintf(stderr, 
 	      _("ERROR: no key given\n Argument must be 'key@path'\n"));
       _exit (EXIT_FAILURE);
@@ -1238,10 +939,4 @@
       return -1;
     }
-
-  len = strlen(new_in) + 1;
-  if (NULL == (new = calloc(1, len)))
-    goto bail_mem;
-  memcpy(new, new_in, len);
-
   key = new;
   len = strlen(new);
@@ -1255,7 +950,6 @@
   if (j == 0)
     {
-      fprintf(stderr, "%s",
+      fprintf(stderr, 
 	      _("ERROR: no path to executable given\n Argument must be 'key@path'\n"));
-      free(new);
       _exit (EXIT_FAILURE);
       /*@notreached@*/
@@ -1264,18 +958,17 @@
   else
     path = &new[j];
-
-  len = strlen(path) + 1 + 4;
   /*@-usedef@*/
-  if (NULL == (outpath = calloc(1,len)))
+  if (NULL == (outpath = malloc(strlen(path) + 1 + 4)))
     goto bail_mem;
   /*@-usedef@*/
-  sl_snprintf (outpath, len, _("%s.out"), path);
-
-  fp = sl_open_read(FIL__, __LINE__, path, SL_NOPRIV);
+  /*@-bufferoverflowhigh@*/
+  sprintf (outpath, _("%s.out"), path);               /* known to fit  */ 
+  /*@+bufferoverflowhigh@*/
+
+  fp = sl_open_read(path, SL_NOPRIV);
   if (SL_ISERROR(fp))
     {
       fprintf(stderr, 
 	      _("ERROR: cannot open %s for read (errnum = %ld)\n"), path, fp);
-      free(new); free (outpath);
       _exit (EXIT_FAILURE);
       /*@notreached@*/
@@ -1283,10 +976,9 @@
     }
   
-  fout = sl_open_write(FIL__, __LINE__, outpath, SL_NOPRIV);
+  fout = sl_open_write(outpath, SL_NOPRIV);
   if (SL_ISERROR(fout))
     {
       fprintf(stderr, 
 	      _("ERROR: cannot open %s (errnum = %ld)\n"), outpath, fout);
-      free(new); free (outpath);
       _exit (EXIT_FAILURE);
       /*@notreached@*/
@@ -1295,17 +987,12 @@
 
 
-  image = calloc(1,4096);
+  image = malloc (4096);
   if (!image)
     goto bail_mem;
   while (0 < (ii = sl_read (fp, &image[s], 4096)))
     {
-      unsigned char * ptr;
       ilen += ii;
       s    += 4096;
-      ptr = realloc (image, (size_t) (4096 + s));
-      if (ptr)
-	image = ptr;
-      else
-	{ free(image); image = NULL; }
+      image = realloc (image, (size_t) (4096 + s));
       if (!image)
 	goto bail_mem;
@@ -1326,10 +1013,7 @@
 	  image[k+7] == new_key[7])
 	{
-	  UINT32 kbuf[KEY_BYT/sizeof(UINT32)];
-
-	  printf("%s", _("old key found\n")); 
+	  printf(_("old key found\n")); 
 	  h1 = sh_tiger_hash_uint32 (key, TIGER_DATA, 
-				     (unsigned long)strlen(key),
-				     kbuf, KEY_BYT/sizeof(UINT32));
+				     (unsigned long)strlen(key));
 	  copy_four( (unsigned char *) &(image[k]),   h1[0]);
 	  copy_four( (unsigned char *) &(image[k+4]), h1[1]);
@@ -1337,5 +1021,4 @@
 	  (void) sl_close (fout);
 	  printf(_("new file %s written\n"), outpath);
-	  free(new); free (outpath); free(image);
 	  _exit (EXIT_SUCCESS);
 	  /*@notreached@*/
@@ -1344,7 +1027,6 @@
     }
 
-  fprintf(stderr, "%s",
+  fprintf(stderr, 
 	  _("ERROR: old key not found\n"));
-  free(new); free (outpath); free(image);
   _exit (EXIT_FAILURE);
   /*@notreached@*/
@@ -1353,9 +1035,6 @@
 
  bail_mem:
-  fprintf(stderr, "%s",
+  fprintf(stderr, 
 	  _("ERROR: out of memory\n"));
-  if (new) free(new); 
-  if (outpath) free (outpath);
-  if (image) free (image);
   _exit (EXIT_FAILURE);
   /*@notreached@*/
@@ -1378,5 +1057,4 @@
   register int    i, j, j1 = 0, j2 = 0, j3;
   char          * dez; 
-  char hashbuf[KEYBUF_SIZE];
 
   SL_ENTER(_("sh_util_encode"));
@@ -1398,16 +1076,13 @@
 
   (void) sl_strlcpy(skey->vernam, 
-		    sh_tiger_hash(skey->vernam, TIGER_DATA, KEY_LEN,
-				  hashbuf, sizeof(hashbuf)), 
+		    sh_tiger_hash(skey->vernam, TIGER_DATA, KEY_LEN), 
 		    KEY_LEN+1);
 
   (void) sl_strlcpy(skey->vernam, 
-		    sh_util_hmac_tiger (skey->vernam, salt, strlen(salt),
-					hashbuf, sizeof(hashbuf)),
-		    KEY_LEN+1);
+		    sh_util_hmac_tiger (skey->vernam, salt, strlen(salt)),
+	     KEY_LEN+1);
 
   (void) sl_strlcpy(skey->vernam, 
-		    sh_util_hmac_tiger (skey->vernam, (char*) new_key, 8,
-					hashbuf, sizeof(hashbuf)),
+		    sh_util_hmac_tiger (skey->vernam, (char*) new_key, 8),
 		    KEY_LEN+1);
 
@@ -1441,15 +1116,17 @@
 /* server mode 
  */
-int sh_util_setserver (const char * dummy)
+int sh_util_setserver (char * dummy)
 {
   SL_ENTER(_("sh_util_setserver"));
 
-  (void) dummy;
-  sh.flag.isserver = GOOD;
+  if (dummy)
+    sh.flag.isserver = GOOD;
+  else
+    sh.flag.isserver = GOOD;
   SL_RETURN((0),_("sh_util_setserver"));
 }
 
 
-int sh_util_setlooptime (const char * str)
+int sh_util_setlooptime (char * str)
 {
   int i = atoi (str);
@@ -1468,5 +1145,5 @@
 
 #if defined (SH_WITH_CLIENT) || defined (SH_STANDALONE)
-int  sh_util_setchecksum (const char * str)
+int  sh_util_setchecksum (char * str)
 {
   static int reject = 0;
@@ -1566,5 +1243,4 @@
   int          status = 0;
   char       * p;
-  char hashbuf[KEYBUF_SIZE];
 
   SL_ENTER(_("sh_util_keyinit"));
@@ -1584,9 +1260,9 @@
 
   for (i = 0; i < 6; ++i)
-    bufy[i] = taus_get();
+    bufy[i] = taus_get(&(skey->rng0[0]), &(skey->rng1[0]), &(skey->rng2[0]));
 
   p = sh_tiger_hash ((char *) bufy, TIGER_DATA, 
-		     (unsigned long)(6*sizeof(UINT32)),
-		     hashbuf, sizeof(hashbuf));
+		     (unsigned long)(6*sizeof(UINT32)));
+  p[size-1] = '\0';
 
   i = sl_strlcpy(buf, p, (size_t)size);
